#ifndef NEMO_BYTE_H
#define NEMO_BYTE_H

#ifdef __cplusplus
extern "C" {
#endif

unsigned int	byte_chr(const void *s, unsigned int len, char c);
unsigned int	byte_rchr(const void *s, unsigned int len, char c);

unsigned int	byte_count(const void *s, unsigned int len, char c);

void		byte_copy(void *to, unsigned int len, const void *from);
void		byte_copyr(void *to, unsigned int len, const void *from);

int		byte_diff(const void *s, unsigned int len, const void *t);
unsigned int	byte_equal(const void *s, unsigned int len, const void *t);

int		byte_case_diff(const void *d1, unsigned int len, const void *d2);
unsigned int	byte_case_equal(const void *d1, unsigned int len, const void *d2);
unsigned int	byte_case_starts(const void *data, unsigned int len, const char *s);

void		byte_fill(void *d, unsigned int n, unsigned char c);  /* fill *d with n c's */
void		byte_zero(void *d, unsigned int n);  /* fill *d with n zeros */

void		byte_lower(void *d, unsigned int len);
void		byte_upper(void *d, unsigned int len);

#ifdef __cplusplus
}
#endif

#endif
