#include <unistd.h>

void _exit(int);

#define BUF_LEN 16

static void outs(const void *s)
{
  const unsigned char *x;

  x = s;
  while (*x) {
    if (write(1, x, 1) < 0) _exit(111);
    x++;
  }
}

static void outbuf(const unsigned char *buf, unsigned int len)
{
  unsigned int i;
  unsigned char octal[4];
  unsigned char ch;

  for (i = 0; i < len; i++) {
    ch = buf[i];
    outs("'\\");
    octal[3] = '\0';
    octal[2] = (unsigned char)('0' + (ch & 7));
    ch >>= 3;
    octal[1] = (unsigned char)('0' + (ch & 7));
    ch >>= 3;
    octal[0] = (unsigned char)('0' + (ch & 7));
    outs(octal);
    outs("',");
  }
}

static int getbuf(void *buf, unsigned int len)
{
  return (int)read(0, buf, len);
}

int main(int argc, char **argv)
{
  unsigned char buf[BUF_LEN];
  int r;

  if (argc != 2) _exit(100);

  outs("/*\n  WARNING: This file was auto-generated. Do not edit!\n*/\n");

  outs("const char ");
  outs(argv[1]);
  outs("[] = {\n");

  while ((r = getbuf(buf, BUF_LEN)) > 0) {
    outbuf(buf, (unsigned int)r);
    outs("\n");
  }
  outs("'\\0'\n};\n");
  _exit(0);
}
