#include <sys/types.h>
#include <unistd.h>
#include <pwd.h>

#include "fmt.h"

void _exit(int);

static void outs(const char *s)
{
  while (*s) {
    if (write(1, s, 1) < 0) _exit(111);
    s++;
  }
}

static void err(const char *s)
{
  while (*s) {
    if (write(2, s, 1) < 0) _exit(111);
    s++;
  }
}

int main(int argc, char **argv)
{
  struct passwd *pw;
  char strnum[FMT_ULONG];

  if (argc != 3) _exit(100);

  pw = getpwnam(argv[2]);
  if (!pw) {
    err("fatal: unable to find user ");
    err(argv[2]);
    err("\n");
    _exit(111);
  }

  strnum[fmt_ulong(strnum, (unsigned long) pw->pw_uid)] = '\0';

  outs("/*\n  WARNING: This file was auto-generated. Do not edit!\n*/\n");

  outs("const unsigned int ");
  outs(argv[1]);
  outs(" = ");
  outs(strnum);
  outs(";\n");
  _exit(0);
}
