#include <unistd.h>

#include "scan.h"
#include "fmt.h"

void _exit(int);

static void outs(const char *s)
{
  while (*s) {
    if (write(1, s, 1) < 0) _exit(111);
    s++;
  }
}

int main(int argc, char **argv)
{
  unsigned long num;
  char strnum[FMT_ULONG];

  if (argc != 3) _exit(100);

  scan_ulong(argv[2], &num);
  strnum[fmt_ulong(strnum, num)] = '\0';

  outs("/*\n  WARNING: This file was auto-generated. Do not edit!\n*/\n");

  outs("const unsigned int ");
  outs(argv[1]);
  outs(" = ");
  outs(strnum);
  outs(";\n");
  _exit(0);
}
