#ifndef NEMO_CONSTMAP_H
#define NEMO_CONSTMAP_H

#ifdef __cplusplus
extern "C" {
#endif

typedef uint64_t constmap_hash;

struct constmap {
  unsigned int num;
  unsigned int flag_assoc_pair;
  constmap_hash mask;
  constmap_hash *hash;
  int *first;
  int *next;
  const char **input;
  unsigned int *inputlen;
};

#define CONSTMAP { 0, 0, 0, 0, 0, 0, 0, 0 }

/* each entry of 'list' must be null terminated, cf sa_vector_0() and set to lower case as appropiate */
unsigned int	constmap_init(struct constmap *cm, const sa_vector *list, unsigned int flag_colon);
void		constmap_free(struct constmap *cm);
const char	*constmap(const struct constmap *cm, const char *s, unsigned int len);

#ifdef __cplusplus
}
#endif

#endif
