#include <stdio.h>

#include "cpu.h"

const char *cpu_abi_name(void)
{
#if defined(__amd64__) || defined(__x86_64__) || defined(__AMD64__) || defined(_M_X64) || defined(_M_AMD64) || defined(__amd64)
  return "amd64";
#elif defined(__i386__) || defined(__i486__) || defined(__i586__) || defined(__i686__) || defined(__x86__) || defined(__X86__) || defined(_M_IX86) || defined(__i386)
  return "x86";
#elif defined(__ia64__) || defined(__IA64__) || defined(__M_IA64)
  return "ia64";
#elif defined(__SPU__)
  return "cellspu";
#elif defined(__powerpc64__) || defined(__ppc64__) || defined(__PPC64__) || defined(_ARCH_PPC64)
  return "ppc64";
#elif defined(__powerpc__) || defined(__ppc__) || defined(__PPC__) || defined(_ARCH_PPC) || defined(__powerpc)
  return "ppc32";
#elif defined(__sparcv9__) || defined(__sparcv9)
  return "sparcv9";
#elif defined(__sparc_v8__)
  return "sparcv8";
#elif defined(__sparc__) || defined(__sparc)
  if (sizeof(long) == 4) return "sparcv8";
  return "sparcv9";
#elif defined(__ARM_ARCH_9__)
  return "armv9";
#elif defined(__ARM_ARCH_8__)
  return "armv8";
#elif defined(__ARM_ARCH_7__) || defined(__ARM_ARCH_7A__) || defined(__ARM_ARCH_7R__) || defined(__ARM_ARCH_7M__)
  return "armv7";
#elif defined(__ARM_ARCH_6__) || defined(__ARM_ARCH_6J__) || defined(__ARM_ARCH_6K__) || defined(__ARM_ARCH_6Z__) || defined(__ARM_ARCH_6ZK__) || defined(__ARM_ARCH_6T2__)
  return "armv6";
#elif defined(__ARM_ARCH_5__) || defined(__ARM_ARCH_5E__) || defined(__ARM_ARCH_5T__) || defined(__ARM_ARCH_5TE__) || defined(__ARM_ARCH_5TEJ__)
  return "armv5";
#elif defined(__ARM_ARCH_4__) || defined(__ARM_ARCH_4T__)
  return "armv4";
#elif defined(__ARM_ARCH_3__) || defined(__ARM_ARCH_3M__)
  return "armv3";
#elif defined(__ARM_ARCH_2__)
  return "armv2";
#elif defined(__ARM_EABI__)
  return "armeabi";
#elif defined(__arm__)
  return "arm";
#elif defined(__mc68060__) || defined(__MC68060__)
  return "m68060";
#elif defined(__mc68040__) || defined(__MC68040__)
  return "m68040";
#elif defined(__mc68030__) || defined(__MC68030__)
  return "m68030";
#elif defined(__mc68020__) || defined(__MC68020__)
  return "m68020";
#elif defined(__mc68010__)
  return "m68010";
#elif defined(__m68k__) || defined(__mc68000__) || defined(__MC68000__)
  return "m68k";
#elif defined(__mips__) || defined(__mips) || defined(__MIPS__)
#if defined(_ABIO32)
  return "mipso32";
#elif defined(_ABIN32)
  return "mips32";
#else
  return "mips64";
#endif
#else
  return "default";
#endif
}
