#include "stdint.h"
#include "ip4.h"


unsigned int ip4_equal_mask(const ip4_address *ip1, unsigned int mask_depth, const ip4_address *ip2)
{
  unsigned int i;
  unsigned int first_byte;
  byte_t byte_mask;
  byte_t ip1_byte;
  byte_t ip2_byte;

  if (mask_depth > 32) {
    mask_depth = 32;
  }
  first_byte = mask_depth >> 3;  /* div by 8 (bits/byte) */
  for (i = 0; i < first_byte; i++) {
    if (ip1->d[i] != ip2->d[i]) return 0;
  }

  i = 8 - (mask_depth & 7);  /* shift count (from mod 8) */
  if (i == 8) return 1;  /* byte boundary */

  byte_mask = (byte_t)0xff;
  byte_mask = (byte_t)(byte_mask << i);
  ip1_byte = ip1->d[first_byte];
  ip2_byte = ip2->d[first_byte];
  ip1_byte &= byte_mask;
  ip2_byte &= byte_mask;
  return (ip1_byte == ip2_byte);
}
