#include "stdint.h"
#include "scan.h"
#include "ip4.h"

unsigned int ip4_mask_scan(ip4_address *ip, unsigned int *mask_depth, const char *s)
{
  register const char *t;
  register unsigned int fields;
  register unsigned int len;
  unsigned long u;

  ip4_zero(ip);
  *mask_depth = 32;
  t = s;
  fields = 0;
  for (;;) {
    len = scan_ulong(t, &u);
    if (!len) return 0;  /* should have number */
    if (u > 255) return 0;  /* syntax error */
    ip->d[fields++] = u & 0xff;
    t += len;
    if (*t == '/') break;
    if (*t == '\0') break;
    if (*t != '.') return 0;
    if (fields == 4) return 0;  /* found 4th dot */
    t++;
  }
  if (*t == '/') {
    t++;  /* skip '/' */
    len = scan_ulong(t, &u);
    if (!len) return 0;  /* should have number */
    if (u > 32) return 0;
    t += len;
    *mask_depth = (unsigned int)u;
  }
  return (unsigned int)(t - s);
}
