#include "stdint.h"
#include "ip4.h"
/*
  NB: this routine requires the vector to be sorted
*/
unsigned int ip4_vector_find(register const ip4_vector *v, register const ip4_address *ip)
{
  register int low;
  register int mid;
  register int high;
  register int cond;
  low = 0;
  high = (int)(v->len) - 1;
  while (low <= high) {
    mid = (low + high) / 2;
    cond = ip4_diff(ip, &v->va[mid]);
    if (!cond) return (unsigned int)mid;
    if (cond < 0) {
      high = mid - 1;
    }
    else {
      low = mid + 1;
    }
  }
  return v->len;
}
