#include "stdint.h"
#include "ip4.h"

/*
  remove element 'i' by shuffle down,
*/
void ip4_vector_remove(register ip4_vector *v, register unsigned int pos, unsigned int len)
{
  register ip4_address *dest;
  register ip4_address *src;
  register unsigned int last;

  if (pos >= v->len) return;  /* pos is outside of data */
  last = v->len - len;
  if (pos >= last) {  /* pos+len is outside of data --> trim */
    v->len = pos;
    return;
  }
  dest = v->va + pos;
  src = dest + len;
  while (pos < last) {  /* shuffle down */
    *dest++ = *src++;
    pos++;
  }
  v->len = last;
}
