#include "stdint.h"
#include "ip4.h"
#include "ip6.h"

static const ip6_address private_null_ip6 = {{'\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'},0};
const ip6_address *null_ip6 = &private_null_ip6;

static const ip6_address private_localhost_ip6 = {{'\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\1'},0};
const ip6_address *localhost_ip6 = &private_localhost_ip6;

static const ip6_address private_localnet_ip6 = {{(byte_t)'\376','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'},0};
const ip6_address *localnet_ip6 = &private_localnet_ip6;

static const ip6_address private_mcastprefix_ip6 = {{(byte_t)'\377','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'},0};
const ip6_address *mcastprefix_ip6 = &private_mcastprefix_ip6;

static const ip6_address private_allnodes_ip6 = {{(byte_t)'\377','\2','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\1'},0};
const ip6_address *allnodes_ip6 = &private_allnodes_ip6;

static const ip6_address private_allrouters_ip6 = {{(byte_t)'\377','\2','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\2'},0};
const ip6_address *allrouters_ip6 = &private_allrouters_ip6;

static const ip6_address private_allhosts_ip6 = {{(byte_t)'\377','\2','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\1'},0};
const ip6_address *allhosts_ip6 = &private_allhosts_ip6;

static const ip6_address private_v4_mapped_prefix = {{'\0','\0','\0','\0','\0','\0','\0','\0','\0','\0',(byte_t)'\377',(byte_t)'\377','\0','\0','\0','\0'},0};
const ip6_address *ip6_v4_mapped_prefix = &private_v4_mapped_prefix;
