#include "stdint.h"
#include "fmt.h"
#include "ip4.h"
#include "ip6.h"

unsigned int ip6_fmt_uncompressed(const ip6_address *ip, void *out)
{
  register unsigned int len;
  register unsigned int i;
  register unsigned int j;
  register unsigned long u;
  register char *s;
  register const byte_t *x;

  s = out;
  x = ip->d;
  len = 0;
  for (j = 0; j < 8; j++) {
    if (j) {
      if (out) {
	*s++ = ':';
      }
      ++len;
    }
    u = (unsigned long)*x << 8;
    x++;
    u |= (unsigned long)*x;
    x++;
    i = fmt_xlong(s, u);
    len += i;
    if (out) {
      s += i;
    }
  }
  if (ip->sid) {
    if (out) {
      *s++ = '%';
    }
    ++len;
    len += fmt_ulong(s, ip->sid);
  }

  return len;
}
