#include "stdint.h"
#include "scan.h"
#include "ip4.h"
#include "ip6.h"

unsigned int ip6_mask_scan(ip6_address *ip, unsigned int *mask_depth, const char *s)
{
  register const char *t;
  register unsigned int fields;
  register unsigned int len;
  unsigned long u;

  ip6_zero(ip);
  *mask_depth = 128;
  t = s;
  fields = 0;
  for (;;) {
    len = scan_xlong(t, &u);
    if (!len) return 0;
    if (u > 0xffff) return 0;
    ip->d[fields++] = (byte_t)(u >> 8);
    ip->d[fields++] = u & 0xff;
    t += len;
    if (*t == '/') break;
    if (*t == '\0') break;
    if (*t != ':') return 0;
    if (fields == 32) return 0;  /* found 16th colon */
    t++;
  }
  if (*t == '/') {
    t++;  /* skip '/' */
    len = scan_ulong(t, &u);
    if (!len) return 0;  /* should have number */
    if (u > 128) return 0;
    t += len;
    *mask_depth = (unsigned int)u;
  }
  return (unsigned int)(t - s);
}
