#include "stdint.h"
#include "scan.h"
#include "ip4.h"
#include "ip6.h"

unsigned int ip6_mask_scanbracket(ip6_address *ip, unsigned int *mask_depth, const char *s)
{
  register unsigned int len;
  register unsigned int fields;
  register const char *t;
  unsigned long u;

  ip6_zero(ip);
  *mask_depth = 128;
  t = s;
  fields = 0;
  if (*t != '[') return 0;
  for (;;) {
    len = scan_xlong(t, &u);
    if (!len) return 0;  /* format error */
    ip->d[fields++] = (byte_t)(u >> 8);
    ip->d[fields++] = u & 0xff;
    t += len;
    if (*t == ']') break;
    if (*t != ':') return 0;  /* syntax error */
    if (fields == 32) return 0;  /* found 16th colon */
    t++;
  }
  t++;  /* skip ']' */
  if (*t == '/') {
    t++;  /* skip '/' */
    len = scan_ulong(t, &u);
    if (!len) return 0;  /* format error */
    if (u > 128) return 0;  /* oversize mask */
    t += len;
    *mask_depth = (unsigned int)u;
  }

  return (unsigned int)(t - s);
}
