#include "stdint.h"
#include "scan.h"
#include "ip4.h"
#include "ip6.h"

unsigned int ip6_port_scan(ip6_address *ip, unsigned int *port, register const char *s)
{
  register unsigned int i;
  register unsigned int len;
  unsigned long u;

  *port = 0;
  i = ip6_scanbracket(ip, s);
  if (!i) return 0;
  len = i;
  s += i;
  if (*s == '\0') return len;
  if (*s != ':') return 0;
  s++;
  len++;
  i = scan_ulong(s, &u);
  if (s[i]) return 0;  /* should have ended on '\0' */
  if (u > 0xffff) return 0;
  len += i;
  *port = (unsigned int)u;
  return len;
}
