#include "stdint.h"
#include "ip4.h"
#include "ip6.h"

/*
  reverse IPv6 address by swapping nibbles (4 bits), not bytes (cf IPv4)
*/

void ip6_reverse(ip6_address *ip)
{
  register byte_t *x;
  register byte_t *y;
  register byte_t xc;
  register byte_t yc;

  x = ip->d;
  y = x + 15;

  /* 0 <-> 15 */
  xc = *x;
  yc = *y;
  *x = yc >> 4 | (byte_t)(yc << 4);
  *y = xc >> 4 | (byte_t)(xc << 4);
  x++;
  y--;

  /* 1 <-> 14 */
  xc = *x;
  yc = *y;
  *x = yc >> 4 | (byte_t)(yc << 4);
  *y = xc >> 4 | (byte_t)(xc << 4);
  x++;
  y--;

  /* 2 <-> 13 */
  xc = *x;
  yc = *y;
  *x = yc >> 4 | (byte_t)(yc << 4);
  *y = xc >> 4 | (byte_t)(xc << 4);
  x++;
  y--;

  /* 3 <-> 12 */
  xc = *x;
  yc = *y;
  *x = yc >> 4 | (byte_t)(yc << 4);
  *y = xc >> 4 | (byte_t)(xc << 4);
  x++;
  y--;

  /* 4 <-> 11 */
  xc = *x;
  yc = *y;
  *x = yc >> 4 | (byte_t)(yc << 4);
  *y = xc >> 4 | (byte_t)(xc << 4);
  x++;
  y--;

  /* 5 <-> 10 */
  xc = *x;
  yc = *y;
  *x = yc >> 4 | (byte_t)(yc << 4);
  *y = xc >> 4 | (byte_t)(xc << 4);
  x++;
  y--;

  /* 6 <->  9 */
  xc = *x;
  yc = *y;
  *x = yc >> 4 | (byte_t)(yc << 4);
  *y = xc >> 4 | (byte_t)(xc << 4);
  x++;
  y--;

  /* 7 <->  8 */
  xc = *x;
  yc = *y;
  *x = yc >> 4 | (byte_t)(yc << 4);
  *y = xc >> 4 | (byte_t)(xc << 4);
}
