#include "stdint.h"
#include "ip4.h"
#include "ip6.h"

/*
  remove element 'i' by shuffle down,
  then shorten length by 1
*/
void ip6_vector_remove(register ip6_vector *v, register unsigned int pos, register unsigned int len)
{
  register ip6_address *dest;
  register ip6_address *src;
  register unsigned int last;

  if (pos >= v->len) return;  /* pos is outside of data */
  if (pos + len >= v->len) {  /* pos+len is outside of data --> trim */
    v->len = pos;
    return;
  }
  last = v->len - len;
  dest = v->va + pos;
  src = dest + len;
  while (pos < last) {  /* shuffle down */
    *dest++ = *src++;
    pos++;
  }
  v->len = last;
}
