#include "alloc.h"
#include "stralloc.h"
#include "sa_vector.h"

#define BASE 10

#define	DATA_SIZE sizeof(stralloc)

static inline void init_data(register stralloc sa[], register unsigned int i, register unsigned int n)
{
  while (i < n) {
    stralloc_init(&sa[i]);
    i++;
  }
}

unsigned int sa_vector_realloc(register sa_vector *v, register unsigned int n)
{
  register unsigned int i;

  i = v->a;
  v->a = BASE + n + (n >> 3);
  if (alloc_re((void **)&(v->va), i * DATA_SIZE, v->a * DATA_SIZE)) {
    init_data(v->va, i, v->a);
    return 1;
  }
  v->a = i;
  return 0;
}

unsigned int sa_vector_alloc(register sa_vector *v, register unsigned int n)
{
  v->len = 0;
  v->a = BASE + n + (n >> 3);
  if ((v->va = (stralloc *)alloc(v->a * DATA_SIZE))) {
    init_data(v->va, 0, v->a);
    return 1;
  }
  return 0;
}
