#include "stralloc.h"
#include "sa_vector.h"

void sa_vector_remove(register sa_vector *v, register unsigned int pos, register unsigned int len)
{
  register unsigned int i;
  register unsigned int last;

  if (pos >= v->len) return;  /* pos is outside of data */
  if (pos + len >= v->len) {  /* pos+len is outside of data --> trim */
    v->len = pos;
    return;
  }
  /* free the deleted data */
  last = pos + len;
  for (i = pos; i < last; i++) {
    stralloc_free(&v->va[i]);
  }
  /* move (copy/shuffle) strallocs */
  last = v->len - len;
  for (i = pos; i < last; i++) {
    v->va[i] = v->va[i + len];
  }
  /* remove 2nd refs to strallocs */
  last = v->len;
  for (i = v->len - len; i < last; i++) {
    stralloc_init(&v->va[i]);
  }
  /* adjust length */
  v->len -= len;
}
