/* Public domain. */

#include <signal.h>
#include "sig.h"

#define X(e, s) if (i == e) return s;

const char *sig_name(register int i)
{
  X(sig_hangup, "SIGHUP")
  X(SIGINT, "SIGINT")
  X(SIGQUIT, "SIGQUIT")
  X(SIGILL, "SIGILL")
  X(SIGTRAP, "SIGTRAP")
  X(SIGABRT, "SIGABRT")
#ifdef SIGEMT
  X(SIGEMT, "SIGEMT")  /* non-posix */
#endif
  X(SIGFPE, "SIGFPE")
  X(sig_kill, "SIGKILL")
  X(SIGBUS, "SIGBUS")
  X(SIGSEGV, "SIGSEGV")
  X(SIGSYS, "SIGSYS")
  X(sig_pipe, "SIGPIPE")
  X(sig_alarm, "SIGALRM")
  X(sig_term, "SIGTERM")
  X(SIGURG, "SIGURG")
  X(SIGSTOP, "SIGSTOP")
  X(SIGTSTP, "SIGTSTP")
  X(sig_cont, "SIGCONT")
  X(sig_child, "SIGCHLD")
  X(SIGTTIN, "SIGTTIN")
  X(SIGTTOU, "SIGTTOU")
#ifdef SIGIO
  X(SIGIO, "SIGIO")  /* non-posix */
#endif
  X(SIGXCPU, "SIGXCPU")
  X(SIGXFSZ, "SIGXFSZ")
  X(SIGVTALRM, "SIGVTALRM")
  X(SIGPROF, "SIGPROF")
#ifdef SIGWINCH
  X(SIGWINCH, "SIGWINCH")  /* non-posix */
#endif
#ifdef SIGINFO
  X(SIGINFO, "SIGINFO")  /* non-posix */
#endif
  X(SIGUSR1, "SIGUSR1")
  X(SIGUSR2, "SIGUSR2")
#ifdef SIGTHR
  X(SIGTHR, "SIGTHR")  /* non-posix */
#endif
#ifdef SIGCKPT
  X(SIGCKPT, "SIGCKPT")  /* non-posix */
#endif
#ifdef SIGCKPTEXIT
  X(SIGCKPTEXIT, "SIGCKPTEXIT")  /* non-posix */
#endif
#ifdef SIGPWR
  X(SIGPWR, "SIGPWR")  /* non-posix */
#endif
#ifdef SIGLOST
  X(SIGLOST, "SIGLOST")  /* non-posix */
#endif
#ifdef SIGPOLL
  X(SIGPOLL, "SIGPOLL")  /* non-bsd */
#endif
  return 0;
}
