/* XXX: this needs testing */

#include "stdint.h"
#include "surf.h"
#include "surfpcs.h"

void surfpcs_init(surfpcs *s, const uint32_t seed[32])
{
  unsigned int i;
  for (i = 0; i < 32; ++i) {
    s->seed[i] = seed[i];
  }
  for (i = 0; i < 8; ++i) {
    s->sum[i] = 0;
  }
  for (i = 0; i < 12; ++i) {
    s->in[i] = 0;
  }
  s->todo = 0;
}

static uint32_t littleendian[8] = {
  50462976,  117835012,  185207048,  252579084,
  319951120,  387323156,  454695192,  522067228
};
#define end ((byte_t*) &littleendian)

#define data ((byte_t*) s->in)
#define outdata ((byte_t*) s->out)

void surfpcs_add(surfpcs *s, const void *buf, unsigned int len)
{
  unsigned int i;
  const byte_t *x;
  x = buf;
  while (len--) {
    data[end[s->todo++]] = *x++;
    if (s->todo == 32) {
      s->todo = 0;
      if (!++s->in[8]) {
        if (!++s->in[9]) {
          if (!++s->in[10]) {
            ++s->in[11];
          }
        }
      }
      surf(s->out, s->in, s->seed);
      for (i = 0; i < 8; ++i) {
        s->sum[i] += s->out[i];
      }
    }
  }
}

void surfpcs_out(surfpcs *s, byte_t h[SURFPCS_LEN])
{
  unsigned int i;
  surfpcs_add(s, ".", 1);
  while (s->todo) {
    surfpcs_add(s, "", 1);
  }
  for (i = 0; i < 8; ++i) {
    s->in[i] = s->sum[i];
  }
  for (; i < 12; ++i) {
    s->in[i] = 0;
  }
  surf(s->out, s->in, s->seed);
  for (i = 0; i < SURFPCS_LEN; ++i) {
    h[i] = outdata[end[i]];
  }
}
