#ifndef NEMO_TAI_H
#define NEMO_TAI_H

#ifdef __cplusplus
extern "C" {
#endif

struct tai {
  uint64_t x;
};

#define TAI { 0 }
#define TAI_PACK 8

void		tai_unix(struct tai *t, time_t u);
time_t		tai_epoch(const struct tai *t);
uint64_t	tai_seconds(const struct tai *t);

void		tai_now(struct tai *t);

double		tai_approx(const struct tai *t);

void		tai_add(struct tai *t, const struct tai *u, const struct tai *v);
void		tai_sub(struct tai *t, const struct tai *u, const struct tai *v);

unsigned int	tai_less(const struct tai *t, const struct tai *u);

void		tai_uint(struct tai *t, unsigned int u);

void		tai_pack(const struct tai *t, void *d);
void		tai_unpack(struct tai *t, const void *d);

#ifdef __cplusplus
}
#endif

#endif
