#include "stdint.h"
#include "unixtypes.h"
#include "unix.h"

void _exit(int);

static void outs(const char *s)
{
  while (*s) {
    if (write(1, s, 1) < 0) _exit(111);
    s++;
  }
}

static void die_compare(int error, const char *what)
{
  outs("test_stdints: ");
  outs(what);
  outs("\n");
  _exit(error);
}

int main(int argc, char **argv)
{
  if (argc != 1) _exit(111);  /* keep compiler quiet */
  if (!*argv[0]) _exit(111);  /* keep compiler quiet */

  if (sizeof(int16_t) != 2) {
    die_compare(2, "sizeof(uint16_t) != 2");
  }
  if (sizeof(uint16_t) != 2) {
    die_compare(2, "sizeof(uint16_t) != 2");
  }

  if (sizeof(int32_t) != 4) {
    die_compare(4, "sizeof(int32_t) != 4");
  }
  if (sizeof(uint32_t) != 4) {
    die_compare(4, "sizeof(uint32_t) != 4");
  }

  if (sizeof(int64_t) != 8) {
    die_compare(8, "sizeof(int64_t) != 8");
  }
  if (sizeof(uint64_t) != 8) {
    die_compare(8, "sizeof(uint64_t) != 8");
  }

  _exit(0);
}
