#include "stdint.h"
#include "uint32.h"
#include "uint32_vector.h"

void uint32_vector_remove(register uint32_vector *v, register unsigned int pos, unsigned int len)
{
  register uint32_t *dest;
  register uint32_t *src;
  register unsigned int last;

  if (pos >= v->len) return;  /* pos is outside of data */
  if (pos + len >= v->len) {  /* pos+len is outside of data */
    v->len = pos;
    return;
  }
  last = v->len - len;
  dest = v->va + pos;
  src = dest + len;
  while (pos < last) {  /* shuffle down */
    *dest++ = *src++;
    pos++;
  }
  v->len = last;
}
