#include "stralloc.h"
#include "uint_vector.h"

static void my_qsort(register uint_vector *v, register int left, register int right)
{
  register int i;
  register int last;
  if (left >= right) return;
  uint_vector_swap(v, (unsigned int)left, (unsigned int)(left + right)/2);
  last = left;
  for (i = left + 1; i <= right; i++) {
    if (&v->va[i] < &v->va[left]) {
      uint_vector_swap(v, (unsigned int)++last, (unsigned int)i);
    }
  }
  uint_vector_swap(v, (unsigned int)left, (unsigned int)last);
  my_qsort(v, left, last - 1);
  my_qsort(v, last + 1, right);
}

void uint_vector_sort(register uint_vector *v)
{
  if (!v->len) return;
  my_qsort(v, 0, (int)(v->len) - 1);
}
